/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.artifacts.model.minfo;

import gnu.trove.TDoubleArrayList;


public class BedHeightSingle
extends BedHeight
{

    protected int year;
    protected TDoubleArrayList data_gap;
    protected TDoubleArrayList morphWidth;

    public BedHeightSingle() {
        super();
        this.year = -1;
        data_gap = new TDoubleArrayList();
        morphWidth = new TDoubleArrayList();
    }

    public BedHeightSingle(String name) {
        super(name);
        this.year = -1;
        data_gap = new TDoubleArrayList();
        morphWidth = new TDoubleArrayList();
    }

    public void add(
        double value,
        double station,
        double gap,
        double width,
        int year
    ) {
        super.add(value, station);
        this.year = year;
        this.data_gap.add(gap);
        this.morphWidth.add(width);
    }

    public int getYear() {
        return this.year;
    }

    public double getMorphWidth(int idx) {
        return this.morphWidth.getQuick(idx);
    }

    public double getDataGap(int idx) {
        return this.data_gap.getQuick(idx);
    }

    public double getMorphWidth(double station) {
        int index = this.station.indexOf(station);
        return index >= 0 ? morphWidth.getQuick(index): Double.NaN;
    }

    public double getDataGap(double station) {
        int index = this.station.indexOf(station);
        return index >= 0 ? data_gap.getQuick(index) : Double.NaN;
    }

    public double[] getMorphWidths() {
        return this.morphWidth.toNativeArray();
    }
}
